﻿@page "{handler?}/{phoneSid?}"
@model BeamAndGo.Member.Web.Pages.PhoneManagementModel
@using BeamAndGo.Core.Data;
@using Microsoft.AspNetCore.Http;
@{
    ViewData["Title"] = "Phone Management";
    if (Model.IsXHR) Layout = null;
    else Layout = "_Layout";
}


<div class="uk-margin-small">
    <h3>Phone Management</h3>
    @await foreach (var phone in Model.MemberPhones)
    {
        <div class="uk-margin-small @(phone.IsDefault ? "uk-text-bold" : "")">
            <div class="uk-card uk-card-default uk-card-small uk-card-body uk-width-1-1">
                <div uk-grid>
                    <div class="uk-width-expand@s uk-margin-small-top">
                        <p class="uk-form-label"> @(phone.CallingCode.Contains("+") ? "" : "+")@phone.CallingCode @phone.PhoneNumber</p>
                    </div>
                    <div class="uk-width-auto@s uk-margin-remove">
                        <div class="uk-margin-remove uk-text-left@s uk-text-right@m">
                            @if (phone.IsDefault)
                            {
                                <span class="uk-badge uk-label uk-label-success">Primary</span>
                            }
                            @if (phone.IsVerified)
                            {
                                <span class="uk-badge uk-label uk-label-success">Verified</span>
                            }
                            else
                            {
                                <span class="uk-badge uk-label uk-label-warning">Unverified</span>
                            }
                        </div>

                        <div class="uk-margin-medium-top uk-align-right uk-flex-inline">

                            @if (!phone.IsVerified)
                            {
                                <form asp-page-handler="resendverification" 
                                      method="post" 
                                      asp-antiforgery="true" 
                                      asp-route-phoneSid="@phone.Sid" 
                                      data-ajax="true" 
                                      data-ajax-method="post" 
                                      data-ajax-success="resendVerificationSuccess" 
                                      data-ajax-failure="resendVerificationFailed">
                                    <button class="member-phone-resend-verification uk-button uk-button-small" 
                                            style="padding:5px 10px;" 
                                            type="submit" 
                                            SelectedPhoneSid="@phone.Sid">
                                    <i class="fas fa-check uk-margin-small-right"></i>Verify</button>
                                </form>
                            }
                            else
                            {
                                if (!phone.IsDefault)
                                {
                                    <form asp-page-handler="MakePrimary" 
                                          method="post" 
                                          asp-antiforgery="true" 
                                          asp-route-phoneSid="@phone.Sid" 
                                          data-ajax="true" 
                                          data-ajax-method="post" 
                                          data-ajax-success="makePrimaryPhoneSuccess" 
                                          data-ajax-failure="makePrimaryPhoneFailed">
                                        <button class="member-phone-make-primary uk-button uk-button-small uk-text-nowrap" 
                                                style="padding:5px 10px;" 
                                                type="submit" 
                                                SelectedPhoneSid="@phone.Sid">
                                        <i class="fas fa-star uk-margin-small-right"></i>Make Primary</button>
                                    </form>
                                }
                            }

                            @if (!phone.IsDefault)
                            {
                                <div class="uk-margin-small-left">
                                    <button class="member-phone-remove uk-button uk-button-small"
                                            style="padding:5px 10px;"
                                            uk-toggle="target: #modal-phone-remove"
                                            SelectedPhoneSid="@phone.Sid"
                                            memberPhone="@phone.CallingCode @phone.PhoneNumber">
                                        <i class="fas fa-trash"></i>
                                    </button>
                                </div>
                            }
                        </div>
                    </div>
                </div>
            </div>
        </div>
    }

    <form asp-page-handler="add" method="post" asp-antiforgery="true" autocomplete="on" data-ajax="true" data-ajax-method="post" data-ajax-success="addPhoneSuccess" data-ajax-failure="addPhoneFailed">
        <div class="uk-child-width-expand uk-grid-small uk-margin-small-bottom" uk-grid>
            <div class="uk-width-expand">
                <input id="new-phone" class="uk-input phone-padding-left" type="tel" name="Phone" asp-for="FormData.MobileNumber" placeholder="Mobile number">
                <input type="hidden" id="new-phone-mobile" asp-for="FormData.MobileNumber">
                <input type="hidden" id="new-phone-calling-code" asp-for="FormData.CallingCode">
            </div>
            <div class="uk-width-auto">
                <button class="uk-button uk-button-primary uk-align-right uk-margin-remove-bottom" style="padding:0px 10px; margin-left:0px" type="submit"><i class="fas fa-plus"></i></button>
            </div>
        </div>
        <div class="uk-margin-small">
            <span asp-validation-for="FormData.MobileNumber" id="new-phone-error" class="uk-text-danger uk-text-small"></span>
        </div>
    </form>
</div>

<!-- This is the Remove modal -->
<div id="modal-phone-remove" uk-modal class="uk-flex-top">
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body uk-text-center">
            <p>
                Are you sure you want to remove this phone number?
                <i><span id="remove-callingCode"></span> <span id="remove-phone"></span></i>
            </p>

            <form method="post" asp-page-handler="remove" asp-antiforgery="true" data-ajax="true" data-ajax-method="post" data-ajax-success="removePhoneSuccess" data-ajax-failure="removePhoneFailed">
                <input type="hidden" asp-for="@Model.SelectedPhoneSid" id="remove-selected" class="member-phone-remove-input" />

                <button class="uk-button uk-button-primary" type="submit">Ok</button>

                @if (Model.IsXHR)
                {
                    <a class="uk-button uk-button-default" href="#bng-modal" uk-toggle>Cancel</a>
                }
                else
                {
                    <button class="uk-button uk-button-default uk-modal-close">Cancel</button>
                }
            </form>
        </div>
    </div>
</div>
<!-- End of modal -->
<!-- This is the Verification modal -->
<div id="modal-phone-verification" uk-modal>
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body uk-text-center">
            <p>
                An OTP has been sent to your phone number
                <i><span id="modal-phone-for-verified"></span></i>, <br />please enter it below
            </p>
            <form method="post" asp-page-handler="verify" asp-antiforgery="true" data-ajax="true" data-ajax-method="post" data-ajax-success="verifyPhoneSuccess" data-ajax-failure="verifyPhoneFailed">
                <input type="hidden" asp-for="@Model.SelectedPhoneSid" id="remove-selected" class="member-phone-verify-input" />
                <input type="hidden" asp-for="@Model.VerificationPrefix" class="member-prefix-for-verified">
                <div class="uk-margin-small uk-text-center uk-flex">
                    <div class="uk-width-1-6@s phone-margin-left" style="text-align: right;">
                        <h3 id="modal-prefix-for-verified"> </h3>
                    </div>
                    <div class="uk-width-1-4@s">
                        <input class="uk-input" asp-for="@Model.VerificationCode" type="text" maxlength="6" placeholder="000000">
                    </div>
                </div>
                <p>
                    OTP expires in <span id="countdown">2</span> minutes.
                </p>
                <button class="uk-button uk-button-primary" type="submit">Verify</button>
            </form>
            <div class="uk-margin-small">
                <form asp-page-handler="resendverification" method="post" asp-antiforgery="true" data-ajax="true" data-ajax-method="post" data-ajax-success="resendVerificationSuccess" data-ajax-failure="resendVerificationFailed">
                    <input type="hidden" id="resend-selected" asp-for="@Model.SelectedPhoneSid" class="member-phone-verify-input"  />
                    <input class="uk-button uk-button-primary" id="resendBtn" type="submit" name="resend" value="Resend Verification" />
                </form>
            </div>
        </div>
    </div>
</div>
<!-- End of modal -->
<style>
    @@media screen and (min-width: 800px) {
        .phone-margin-left {
            margin-left: 155px !important;
        }
    }

    .iti {
        width: 100% !important;
    }

    .phone-padding-left {
        padding-left: 90px !important;
    }
</style>
<script type="text/javascript">
    var input = document.querySelector("#new-phone");
    var iti = window.intlTelInput(input, {
        autoPlaceholder: "off",
        separateDialCode: true,
        initialCountry: '@Model.MemberCountryCode',
        preferredCountries: ["AU", "CA", "HK", "JP", "MY", "PH", "QA", "SA", "SG", "TW", "AE", "US", "GB"],
        utilsScript:  '@Model.StaticAssetsUrl/js/intl-tel-input/intlTelutils.min.js',
    });

    function handleChange() {
        let country_code = iti.getSelectedCountryData()["dialCode"];
        let number_with_code = iti.getNumber();

        $("#new-phone-mobile").val(number_with_code.replace("+" + country_code, ""));
        $("#new-phone-calling-code").val(country_code.replace("+", ""));
    }

    input.addEventListener("countrychange", handleChange);
    input.addEventListener('change', handleChange);
    input.addEventListener('keyup', handleChange);

    $('.member-phone-remove').click(function () {
        $('.member-phone-remove-input').val($(this).attr('SelectedPhoneSid'));
        $('.remove-phone').html($(this).attr('memberPhone'));
    });

    $('.member-phone-resend-verification').click(function () {
        $('.member-phone-verify-input').val($(this).attr('SelectedPhoneSid'));
    });

    $('.member-phone-make-primary').click(function () {
        $('.member-phone-make-primary-input').val($(this).attr('SelectedPhoneSid'));
    });

    //Resend verification.
    var modalResendVerification = '#modal-phone-verification';
    resendVerificationSuccess = (phone) => {
        var str = phone.split(",");
        $('#modal-phone-for-verified').text(str[0]);
        $('#modal-prefix-for-verified').text(str[1] + "-");
        $('.member-prefix-for-verified').val(str[1]);
          UIkit.modal(modalResendVerification).show();
    };
    resendVerificationFailed = (xhr) => {
        showErrorNotification(xhr.responseText);
    };

    // Change Primary Verification
    makePrimaryPhoneSuccess = (xhr) => {
        location.reload();
        showSuccessNotification(xhr);
    };
    makePrimaryPhoneFailed = (xhr) => {
        showErrorNotification(xhr.responseText);
    };

    // Add Phone
    addPhoneSuccess = (xhr) => {
        location.reload();
        showSuccessNotification(xhr);
    };
    addPhoneFailed = (xhr) => {
        showErrorNotification(xhr.responseText);
    };

    // Remove Phone
    removePhoneSuccess = (xhr) => {
        $("#modal-phone-remove").remove();
        UIkit.modal("#bng-modal").hide();
        showSuccessNotification(xhr);
    };
    removePhoneFailed = (xhr) => {
        UIkit.modal("#bng-modal").show();
        showErrorNotification(xhr.responseText);
    };

    // Phone verification
    verifyPhoneSuccess = (xhr) => {
        $("#modal-phone-verification").remove();
        UIkit.modal("#bng-modal").hide();
        showSuccessNotification(xhr);
    };
    verifyPhoneFailed = (xhr) => {
        UIkit.modal("#bng-modal").show();
        showErrorNotification(xhr.responseText);
    };
</script>
